# Generated by Django 3.2.16 on 2022-11-15 16:10

import django.db.models.deletion
import django.db.models.expressions
import django_countries.fields
import phonenumber_field.modelfields
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Contact",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=1024)),
                ("email", models.EmailField(max_length=254)),
            ],
        ),
        migrations.CreateModel(
            name="Enrollment",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("since", models.DateField()),
                ("until", models.DateField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="Person",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("legal_name", models.CharField(max_length=1024)),
                ("given_name", models.CharField(max_length=1024)),
                ("birth_date", models.DateField(blank=True, null=True)),
                (
                    "contact",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="members.contact",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="StudyProgram",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=256)),
                (
                    "phase",
                    models.CharField(
                        choices=[("ba", "bachelor"), ("ma", "master")], max_length=2
                    ),
                ),
                (
                    "students",
                    models.ManyToManyField(
                        through="members.Enrollment", to="members.Person"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="PhoneNumber",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "kind",
                    models.CharField(
                        choices=[
                            ("home", "home"),
                            ("mobile", "mobile"),
                            ("work", "work"),
                            ("emergency", "emergency"),
                        ],
                        default="home",
                        max_length=9,
                    ),
                ),
                (
                    "number",
                    phonenumber_field.modelfields.PhoneNumberField(
                        max_length=128, region=None
                    ),
                ),
                (
                    "person",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="members.person"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Membership",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "kind",
                    models.CharField(
                        choices=[
                            ("member", "member"),
                            ("bal", "BAL"),
                            ("merit", "member of merit"),
                            ("honorary", "honorary member"),
                        ],
                        default="member",
                        max_length=8,
                    ),
                ),
                ("since", models.DateField()),
                ("until", models.DateField(blank=True, null=True)),
                (
                    "person",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="members.person"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="enrollment",
            name="person",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="members.person"
            ),
        ),
        migrations.AddField(
            model_name="enrollment",
            name="program",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT, to="members.studyprogram"
            ),
        ),
        migrations.CreateModel(
            name="Address",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "kind",
                    models.CharField(
                        choices=[
                            ("home", "home address"),
                            ("billing", "billing address"),
                            ("parents", "parents' address"),
                            ("postal", "postal address"),
                        ],
                        default="home",
                        max_length=7,
                    ),
                ),
                ("street", models.CharField(max_length=256)),
                ("street_number", models.CharField(max_length=16)),
                ("extra", models.CharField(blank=True, max_length=256)),
                ("postal_code", models.CharField(max_length=16)),
                ("city", models.CharField(max_length=256)),
                (
                    "country",
                    django_countries.fields.CountryField(default="NL", max_length=2),
                ),
                (
                    "person",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="members.person"
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "addresses",
            },
        ),
        migrations.AddConstraint(
            model_name="membership",
            constraint=models.CheckConstraint(
                check=models.Q(
                    ("since__lte", django.db.models.expressions.F("until")),
                    ("until", None),
                    _connector="OR",
                ),
                name="membership_date_range_valid",
            ),
        ),
        migrations.AddConstraint(
            model_name="enrollment",
            constraint=models.CheckConstraint(
                check=models.Q(
                    ("since__lte", django.db.models.expressions.F("until")),
                    ("until", None),
                    _connector="OR",
                ),
                name="enrollment_date_range_valid",
            ),
        ),
    ]
